package com.bweb.excel.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentStyle;
import lombok.Data;
import org.apache.poi.ss.usermodel.HorizontalAlignment;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @className: exportTradeOrderModel
 * @author: HuRui
 * @date: 2023/3/30
 **/
@Data
public class ExportTradeOrderModel {

    @ColumnWidth(25)
    @ExcelProperty(value = "商户号")
    private String merNo;

    @ColumnWidth(25)
    @ExcelProperty(value = "商户名称")
    private String merName;

    @ColumnWidth(20)
    @ExcelProperty(value = "商户简称")
    private String merAbbreviate;

    @ColumnWidth(25)
    @ExcelProperty(value = "门店名称")
    private String storeName;

    @ColumnWidth(35)
    @ExcelProperty(value = "商户交易单号")
    private String outTradeNo;

    @ColumnWidth(35)
    @ExcelProperty(value = "账户端交易单号")
    private String accTradeNo;

    @ColumnWidth(20)
    @ExcelProperty(value = "支付方式")
    private String payMode;

    @ColumnWidth(20)
    @ExcelProperty(value = "交易金额")
    @ContentStyle(horizontalAlignment = HorizontalAlignment.LEFT)
    private BigDecimal tradeAmount;

    @ColumnWidth(20)
    @ExcelProperty(value = "门店优惠")
    @ContentStyle(horizontalAlignment = HorizontalAlignment.LEFT)
    private BigDecimal storeDiscountActualPrice;

    @ColumnWidth(20)
    @ExcelProperty(value = "优惠券优惠")
    @ContentStyle(horizontalAlignment = HorizontalAlignment.LEFT)
    private BigDecimal userDiscountActualPrice;

    @ColumnWidth(20)
    @ExcelProperty(value = "实付金额")
    @ContentStyle(horizontalAlignment = HorizontalAlignment.LEFT)
    private BigDecimal tradeActualAmount;

    @ColumnWidth(20)
    @ExcelProperty(value = "交易状态")
    private String status;

    @ColumnWidth(20)
    @ExcelProperty(value = "创建方式")
    private String createType;

    @ColumnWidth(25)
    @ExcelProperty(value = "创建时间")
    private Date createTime;

    @ColumnWidth(25)
    @ExcelProperty(value = "交易时间")
    private Date payTime;

    @ColumnWidth(25)
    @ExcelProperty(value = "入账商户号")
    private String platformMerNo;

    @ColumnWidth(25)
    @ExcelProperty(value = "业务员")
    private String salesmanName;

    @ColumnWidth(25)
    @ExcelProperty(value = "特殊字段")
    private String specialField;

}
