package com.hfkj.common;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.WriterException;
import com.google.zxing.client.j2se.MatrixToImageWriter;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import com.hfkj.config.CommonSysConst;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

/**
 * @Auther: 胡锐
 * @Description: 生成二维码
 * @Date: 2021/3/27 12:07
 */
public class QRCodeGenerator {

    public static void generateQRCodeImage(String text, int width, int height, String filePath) throws WriterException, IOException {
        QRCodeWriter qrCodeWriter = new QRCodeWriter();

        BitMatrix bitMatrix = qrCodeWriter.encode(text, BarcodeFormat.QR_CODE, width, height);

        File file = new File(filePath);
        if(!file.exists()){
            file.mkdirs();
        }
        //Path path = FileSystems.getDefault().getPath(filePath);
        MatrixToImageWriter.writeToFile(bitMatrix, "PNG", file);

    }


    // 二维码生产自定义图片
    public static void overlapImage(String path , String bgPath , int x, int y) throws Exception {
        BufferedImage read = ImageIO.read(new File(CommonSysConst.getSysConfig().getFilesystem() + bgPath));
        Image image = ImageIO.read(new File(CommonSysConst.getSysConfig().getFilesystem() +  path));

        Graphics graphics = read.getGraphics();

        graphics.drawImage(image, x ,y, null);

        ImageIO.write(read , "png" , new File(CommonSysConst.getSysConfig().getFilesystem() + "/" +  path));
    }


    public static void main(String[] args) {
        try {
            generateQRCodeImage("This is my first QR Code", 350, 350, "D:\\/ss/qr1.png");
        } catch (WriterException e) {
            System.out.println("Could not generate QR Code, WriterException :: " + e.getMessage());
        } catch (IOException e) {
            System.out.println("Could not generate QR Code, IOException :: " + e.getMessage());
        }

    }
}
