package com.hfkj.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

@Component("commonSysConfig")
@ConfigurationProperties
@PropertySource("classpath:/commonConfig.properties")
@Data
public class CommonSysConfig {

    private String wechat_mp_appid;
    private String wechat_mp_secret;

    /**
     * 华为云OBS桶名称
     */
    private String obs_bucket_name;

    /**
     * 华为云Endpoint
     */
    private String obs_end_point;

    /**
     * 华为云OBSURL
     */
    private String obs_url;

    /**
     * 二维码URL
     */
    private String qr_code_url;

    /**
     * 二维码数据地址
     */
    private String qr_code_data_url;

    /**
     * 拉卡拉请求地址
     */
    private String lkl_request_url;

    /**
     * 拉卡拉机构代码
     */
    private String lkl_org_code;

    /**
     * 拉卡拉V3版本 APPId
     */
    private String lkl_v3_appid;

    /**
     * 拉卡拉V3版本 证书序列号
     */
    private String lkl_v3_serial_no;

    /**
     * 拉卡拉V3版本 私钥
     */
    private String lkl_v3_private_key;

    /**
     * 拉卡拉V2版本 APPId
     */
    private String lkl_v2_appid;

    /**
     * 拉卡拉V2版本 证书序列号
     */
    private String lkl_v2_serial_no;

    /**
     * 拉卡拉V2版本 私钥
     */
    private String lkl_v2_private_key;

    /**
     * 拉卡拉进件回调地址
     */
    private String lkl_mer_contract_ret_url;

    /**
     * 拉卡拉SAAS请求地址、秘钥
     */
    private String lkl_micro_pay_ret_url;
    private String lkl_open_api_pay_notify_url;
    private String lkl_saas_client_id;
    private String lkl_saas_client_secret;
    private String lkl_saas_activity_id;
    private String lkl_saas_user_no;
    private String lkl_saas_request_url;
    private String lkl_saas_request_mer_registration_token_url;
    private String lkl_saas_request_mer_registration_url;
    private String lkl_saas_request_mer_update_url;
    private String lkl_saas_request_mer_registration_common_url;
    private String lkl_saas_request_mer_url;
    private String lkl_saas_public_key;
    private String lkl_saas_private_key;

    /**
     * 【随行付】天阙请求地址
     */
    private String tianque_request_url;

    /**
     * 【随行付】天阙请求机构编号
     */
    private String tianque_org_id;

    /**
     * 【随行付】天阙请求私钥
     */
    private String tianque_private_key;

    /**
     * 【随行付】天阙请求公钥
     */
    private String tianque_public_key;

    /**
     * 【随行付】天阙支付回调地址
     */
    private String tianque_micro_pay_ret_url;

    /**
     * 【随行付】天阙支付api回调地址
     */
    private String tianque_open_api_pay_notify_url;

    /**
     * 域名
     */
    private String domainName;
    /**
     * 微信支付回调
     */
    private String wechat_pay_notify_url;


    /**
     * 文件存放地址 不可访问
     */
    private String file_url;

    /**
     * 文件存放地址 可访问
     */
    private String filesystem;

    /**
     * 嗨森逛域名
     */
    private String hsg_domain_name;

}
