package com.hfkj.dao;

import com.hfkj.entity.BsAudit;
import com.hfkj.entity.BsAuditExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsAuditMapper extends BsAuditMapperExt {
    @SelectProvider(type=BsAuditSqlProvider.class, method="countByExample")
    long countByExample(BsAuditExample example);

    @DeleteProvider(type=BsAuditSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsAuditExample example);

    @Delete({
        "delete from bs_audit",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_audit (audit_no, vocational_work_type, ",
        "vocational_work_type_name, audit_object_id, ",
        "audit_object_name, op_user_id, ",
        "op_user_name, reviewed_user_id, ",
        "reviewed_user_name, `status`, ",
        "reject_reason, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{auditNo,jdbcType=VARCHAR}, #{vocationalWorkType,jdbcType=INTEGER}, ",
        "#{vocationalWorkTypeName,jdbcType=VARCHAR}, #{auditObjectId,jdbcType=BIGINT}, ",
        "#{auditObjectName,jdbcType=VARCHAR}, #{opUserId,jdbcType=BIGINT}, ",
        "#{opUserName,jdbcType=VARCHAR}, #{reviewedUserId,jdbcType=BIGINT}, ",
        "#{reviewedUserName,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{rejectReason,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsAudit record);

    @InsertProvider(type=BsAuditSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsAudit record);

    @SelectProvider(type=BsAuditSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="audit_no", property="auditNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="vocational_work_type", property="vocationalWorkType", jdbcType=JdbcType.INTEGER),
        @Result(column="vocational_work_type_name", property="vocationalWorkTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="audit_object_id", property="auditObjectId", jdbcType=JdbcType.BIGINT),
        @Result(column="audit_object_name", property="auditObjectName", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="reviewed_user_id", property="reviewedUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="reviewed_user_name", property="reviewedUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="reject_reason", property="rejectReason", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsAudit> selectByExample(BsAuditExample example);

    @Select({
        "select",
        "id, audit_no, vocational_work_type, vocational_work_type_name, audit_object_id, ",
        "audit_object_name, op_user_id, op_user_name, reviewed_user_id, reviewed_user_name, ",
        "`status`, reject_reason, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_audit",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="audit_no", property="auditNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="vocational_work_type", property="vocationalWorkType", jdbcType=JdbcType.INTEGER),
        @Result(column="vocational_work_type_name", property="vocationalWorkTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="audit_object_id", property="auditObjectId", jdbcType=JdbcType.BIGINT),
        @Result(column="audit_object_name", property="auditObjectName", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="reviewed_user_id", property="reviewedUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="reviewed_user_name", property="reviewedUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="reject_reason", property="rejectReason", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsAudit selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsAuditSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsAudit record, @Param("example") BsAuditExample example);

    @UpdateProvider(type=BsAuditSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsAudit record, @Param("example") BsAuditExample example);

    @UpdateProvider(type=BsAuditSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsAudit record);

    @Update({
        "update bs_audit",
        "set audit_no = #{auditNo,jdbcType=VARCHAR},",
          "vocational_work_type = #{vocationalWorkType,jdbcType=INTEGER},",
          "vocational_work_type_name = #{vocationalWorkTypeName,jdbcType=VARCHAR},",
          "audit_object_id = #{auditObjectId,jdbcType=BIGINT},",
          "audit_object_name = #{auditObjectName,jdbcType=VARCHAR},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "reviewed_user_id = #{reviewedUserId,jdbcType=BIGINT},",
          "reviewed_user_name = #{reviewedUserName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "reject_reason = #{rejectReason,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsAudit record);
}