package com.hfkj.dao;

import com.hfkj.entity.BsBankActivity;
import com.hfkj.entity.BsBankActivityExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsBankActivityMapper extends BsBankActivityMapperExt {
    @SelectProvider(type=BsBankActivitySqlProvider.class, method="countByExample")
    long countByExample(BsBankActivityExample example);

    @DeleteProvider(type=BsBankActivitySqlProvider.class, method="deleteByExample")
    int deleteByExample(BsBankActivityExample example);

    @Delete({
        "delete from bs_bank_activity",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_bank_activity (regions, activity_no, ",
        "activity_name, pos_scope, ",
        "effective_start, effective_end, ",
        "registration_start, registration_end, ",
        "details, comments, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{regions,jdbcType=VARCHAR}, #{activityNo,jdbcType=BIGINT}, ",
        "#{activityName,jdbcType=VARCHAR}, #{posScope,jdbcType=VARCHAR}, ",
        "#{effectiveStart,jdbcType=TIMESTAMP}, #{effectiveEnd,jdbcType=TIMESTAMP}, ",
        "#{registrationStart,jdbcType=TIMESTAMP}, #{registrationEnd,jdbcType=TIMESTAMP}, ",
        "#{details,jdbcType=VARCHAR}, #{comments,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsBankActivity record);

    @InsertProvider(type=BsBankActivitySqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsBankActivity record);

    @SelectProvider(type=BsBankActivitySqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="regions", property="regions", jdbcType=JdbcType.VARCHAR),
        @Result(column="activity_no", property="activityNo", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_name", property="activityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="pos_scope", property="posScope", jdbcType=JdbcType.VARCHAR),
        @Result(column="effective_start", property="effectiveStart", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="effective_end", property="effectiveEnd", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="registration_start", property="registrationStart", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="registration_end", property="registrationEnd", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="details", property="details", jdbcType=JdbcType.VARCHAR),
        @Result(column="comments", property="comments", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsBankActivity> selectByExample(BsBankActivityExample example);

    @Select({
        "select",
        "id, regions, activity_no, activity_name, pos_scope, effective_start, effective_end, ",
        "registration_start, registration_end, details, comments, `status`, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_bank_activity",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="regions", property="regions", jdbcType=JdbcType.VARCHAR),
        @Result(column="activity_no", property="activityNo", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_name", property="activityName", jdbcType=JdbcType.VARCHAR),
        @Result(column="pos_scope", property="posScope", jdbcType=JdbcType.VARCHAR),
        @Result(column="effective_start", property="effectiveStart", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="effective_end", property="effectiveEnd", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="registration_start", property="registrationStart", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="registration_end", property="registrationEnd", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="details", property="details", jdbcType=JdbcType.VARCHAR),
        @Result(column="comments", property="comments", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsBankActivity selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsBankActivitySqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsBankActivity record, @Param("example") BsBankActivityExample example);

    @UpdateProvider(type=BsBankActivitySqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsBankActivity record, @Param("example") BsBankActivityExample example);

    @UpdateProvider(type=BsBankActivitySqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsBankActivity record);

    @Update({
        "update bs_bank_activity",
        "set regions = #{regions,jdbcType=VARCHAR},",
          "activity_no = #{activityNo,jdbcType=BIGINT},",
          "activity_name = #{activityName,jdbcType=VARCHAR},",
          "pos_scope = #{posScope,jdbcType=VARCHAR},",
          "effective_start = #{effectiveStart,jdbcType=TIMESTAMP},",
          "effective_end = #{effectiveEnd,jdbcType=TIMESTAMP},",
          "registration_start = #{registrationStart,jdbcType=TIMESTAMP},",
          "registration_end = #{registrationEnd,jdbcType=TIMESTAMP},",
          "details = #{details,jdbcType=VARCHAR},",
          "comments = #{comments,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsBankActivity record);
}