package com.hfkj.dao;

import com.hfkj.entity.BsBankActivityRoster;
import com.hfkj.entity.BsBankActivityRosterExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsBankActivityRosterMapper extends BsBankActivityRosterMapperExt {
    @SelectProvider(type=BsBankActivityRosterSqlProvider.class, method="countByExample")
    long countByExample(BsBankActivityRosterExample example);

    @DeleteProvider(type=BsBankActivityRosterSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsBankActivityRosterExample example);

    @Delete({
        "delete from bs_bank_activity_roster",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_bank_activity_roster (bank_activity_id, mer_id, ",
        "platform_no, cup_no, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{bankActivityId,jdbcType=BIGINT}, #{merId,jdbcType=BIGINT}, ",
        "#{platformNo,jdbcType=VARCHAR}, #{cupNo,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsBankActivityRoster record);

    @InsertProvider(type=BsBankActivityRosterSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsBankActivityRoster record);

    @SelectProvider(type=BsBankActivityRosterSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="bank_activity_id", property="bankActivityId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsBankActivityRoster> selectByExample(BsBankActivityRosterExample example);

    @Select({
        "select",
        "id, bank_activity_id, mer_id, platform_no, cup_no, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_bank_activity_roster",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="bank_activity_id", property="bankActivityId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsBankActivityRoster selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsBankActivityRosterSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsBankActivityRoster record, @Param("example") BsBankActivityRosterExample example);

    @UpdateProvider(type=BsBankActivityRosterSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsBankActivityRoster record, @Param("example") BsBankActivityRosterExample example);

    @UpdateProvider(type=BsBankActivityRosterSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsBankActivityRoster record);

    @Update({
        "update bs_bank_activity_roster",
        "set bank_activity_id = #{bankActivityId,jdbcType=BIGINT},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "platform_no = #{platformNo,jdbcType=VARCHAR},",
          "cup_no = #{cupNo,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsBankActivityRoster record);
}