package com.hfkj.dao;

import com.hfkj.entity.BsDevice;
import com.hfkj.entity.BsDeviceExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsDeviceMapper extends BsDeviceMapperExt {
    @SelectProvider(type=BsDeviceSqlProvider.class, method="countByExample")
    long countByExample(BsDeviceExample example);

    @DeleteProvider(type=BsDeviceSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsDeviceExample example);

    @Delete({
        "delete from bs_device",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_device (company_id, company_name, ",
        "agent_id, agent_name, ",
        "salesman_id, salesman_name, ",
        "mer_id, mer_name, store_id, ",
        "store_name, device_type, ",
        "device_no, device_imsi, ",
        "device_iccid, `status`, ",
        "bind_status, bind_time, ",
        "op_user_id, op_user_name, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{companyId,jdbcType=BIGINT}, #{companyName,jdbcType=VARCHAR}, ",
        "#{agentId,jdbcType=BIGINT}, #{agentName,jdbcType=VARCHAR}, ",
        "#{salesmanId,jdbcType=BIGINT}, #{salesmanName,jdbcType=VARCHAR}, ",
        "#{merId,jdbcType=BIGINT}, #{merName,jdbcType=VARCHAR}, #{storeId,jdbcType=BIGINT}, ",
        "#{storeName,jdbcType=VARCHAR}, #{deviceType,jdbcType=INTEGER}, ",
        "#{deviceNo,jdbcType=VARCHAR}, #{deviceImsi,jdbcType=VARCHAR}, ",
        "#{deviceIccid,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{bindStatus,jdbcType=BIT}, #{bindTime,jdbcType=TIMESTAMP}, ",
        "#{opUserId,jdbcType=BIGINT}, #{opUserName,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsDevice record);

    @InsertProvider(type=BsDeviceSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsDevice record);

    @SelectProvider(type=BsDeviceSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="company_name", property="companyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="salesman_id", property="salesmanId", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_name", property="salesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="device_type", property="deviceType", jdbcType=JdbcType.INTEGER),
        @Result(column="device_no", property="deviceNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="device_imsi", property="deviceImsi", jdbcType=JdbcType.VARCHAR),
        @Result(column="device_iccid", property="deviceIccid", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="bind_status", property="bindStatus", jdbcType=JdbcType.BIT),
        @Result(column="bind_time", property="bindTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsDevice> selectByExample(BsDeviceExample example);

    @Select({
        "select",
        "id, company_id, company_name, agent_id, agent_name, salesman_id, salesman_name, ",
        "mer_id, mer_name, store_id, store_name, device_type, device_no, device_imsi, ",
        "device_iccid, `status`, bind_status, bind_time, op_user_id, op_user_name, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_device",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="company_name", property="companyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="salesman_id", property="salesmanId", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_name", property="salesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_name", property="storeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="device_type", property="deviceType", jdbcType=JdbcType.INTEGER),
        @Result(column="device_no", property="deviceNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="device_imsi", property="deviceImsi", jdbcType=JdbcType.VARCHAR),
        @Result(column="device_iccid", property="deviceIccid", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="bind_status", property="bindStatus", jdbcType=JdbcType.BIT),
        @Result(column="bind_time", property="bindTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsDevice selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsDeviceSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsDevice record, @Param("example") BsDeviceExample example);

    @UpdateProvider(type=BsDeviceSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsDevice record, @Param("example") BsDeviceExample example);

    @UpdateProvider(type=BsDeviceSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsDevice record);

    @Update({
        "update bs_device",
        "set company_id = #{companyId,jdbcType=BIGINT},",
          "company_name = #{companyName,jdbcType=VARCHAR},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "agent_name = #{agentName,jdbcType=VARCHAR},",
          "salesman_id = #{salesmanId,jdbcType=BIGINT},",
          "salesman_name = #{salesmanName,jdbcType=VARCHAR},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "store_id = #{storeId,jdbcType=BIGINT},",
          "store_name = #{storeName,jdbcType=VARCHAR},",
          "device_type = #{deviceType,jdbcType=INTEGER},",
          "device_no = #{deviceNo,jdbcType=VARCHAR},",
          "device_imsi = #{deviceImsi,jdbcType=VARCHAR},",
          "device_iccid = #{deviceIccid,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "bind_status = #{bindStatus,jdbcType=BIT},",
          "bind_time = #{bindTime,jdbcType=TIMESTAMP},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsDevice record);
}