package com.hfkj.dao;

import com.hfkj.entity.BsIndustry;
import com.hfkj.entity.BsIndustryExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsIndustryMapper extends BsIndustryMapperExt {
    @SelectProvider(type=BsIndustrySqlProvider.class, method="countByExample")
    long countByExample(BsIndustryExample example);

    @DeleteProvider(type=BsIndustrySqlProvider.class, method="deleteByExample")
    int deleteByExample(BsIndustryExample example);

    @Delete({
        "delete from bs_industry",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_industry (parent_id, `name`, ",
        "wechat_company_code, wechat_self_employed_code, ",
        "wechat_name, `status`, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{parentId,jdbcType=BIGINT}, #{name,jdbcType=VARCHAR}, ",
        "#{wechatCompanyCode,jdbcType=VARCHAR}, #{wechatSelfEmployedCode,jdbcType=VARCHAR}, ",
        "#{wechatName,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsIndustry record);

    @InsertProvider(type=BsIndustrySqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsIndustry record);

    @SelectProvider(type=BsIndustrySqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_id", property="parentId", jdbcType=JdbcType.BIGINT),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="wechat_company_code", property="wechatCompanyCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="wechat_self_employed_code", property="wechatSelfEmployedCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="wechat_name", property="wechatName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsIndustry> selectByExample(BsIndustryExample example);

    @Select({
        "select",
        "id, parent_id, `name`, wechat_company_code, wechat_self_employed_code, wechat_name, ",
        "`status`, create_time, ext_1, ext_2, ext_3",
        "from bs_industry",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_id", property="parentId", jdbcType=JdbcType.BIGINT),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="wechat_company_code", property="wechatCompanyCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="wechat_self_employed_code", property="wechatSelfEmployedCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="wechat_name", property="wechatName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsIndustry selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsIndustrySqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsIndustry record, @Param("example") BsIndustryExample example);

    @UpdateProvider(type=BsIndustrySqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsIndustry record, @Param("example") BsIndustryExample example);

    @UpdateProvider(type=BsIndustrySqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsIndustry record);

    @Update({
        "update bs_industry",
        "set parent_id = #{parentId,jdbcType=BIGINT},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "wechat_company_code = #{wechatCompanyCode,jdbcType=VARCHAR},",
          "wechat_self_employed_code = #{wechatSelfEmployedCode,jdbcType=VARCHAR},",
          "wechat_name = #{wechatName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsIndustry record);
}