package com.hfkj.dao;

import com.hfkj.entity.BsMerIndustry;
import com.hfkj.entity.BsMerIndustryExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerIndustryMapper extends BsMerIndustryMapperExt {
    @SelectProvider(type=BsMerIndustrySqlProvider.class, method="countByExample")
    long countByExample(BsMerIndustryExample example);

    @DeleteProvider(type=BsMerIndustrySqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerIndustryExample example);

    @Delete({
        "delete from bs_mer_industry",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_industry (mer_id, parent_id, ",
        "parent_name, child_id, ",
        "child_name, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merId,jdbcType=BIGINT}, #{parentId,jdbcType=BIGINT}, ",
        "#{parentName,jdbcType=VARCHAR}, #{childId,jdbcType=BIGINT}, ",
        "#{childName,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerIndustry record);

    @InsertProvider(type=BsMerIndustrySqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerIndustry record);

    @SelectProvider(type=BsMerIndustrySqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="parent_id", property="parentId", jdbcType=JdbcType.BIGINT),
        @Result(column="parent_name", property="parentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="child_id", property="childId", jdbcType=JdbcType.BIGINT),
        @Result(column="child_name", property="childName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerIndustry> selectByExample(BsMerIndustryExample example);

    @Select({
        "select",
        "id, mer_id, parent_id, parent_name, child_id, child_name, `status`, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_mer_industry",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="parent_id", property="parentId", jdbcType=JdbcType.BIGINT),
        @Result(column="parent_name", property="parentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="child_id", property="childId", jdbcType=JdbcType.BIGINT),
        @Result(column="child_name", property="childName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerIndustry selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerIndustrySqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerIndustry record, @Param("example") BsMerIndustryExample example);

    @UpdateProvider(type=BsMerIndustrySqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerIndustry record, @Param("example") BsMerIndustryExample example);

    @UpdateProvider(type=BsMerIndustrySqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerIndustry record);

    @Update({
        "update bs_mer_industry",
        "set mer_id = #{merId,jdbcType=BIGINT},",
          "parent_id = #{parentId,jdbcType=BIGINT},",
          "parent_name = #{parentName,jdbcType=VARCHAR},",
          "child_id = #{childId,jdbcType=BIGINT},",
          "child_name = #{childName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerIndustry record);
}