package com.hfkj.dao;

import com.hfkj.entity.BsMerLedger;
import com.hfkj.entity.BsMerLedgerExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerLedgerMapper extends BsMerLedgerMapperExt {
    @SelectProvider(type=BsMerLedgerSqlProvider.class, method="countByExample")
    long countByExample(BsMerLedgerExample example);

    @DeleteProvider(type=BsMerLedgerSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerLedgerExample example);

    @Delete({
        "delete from bs_mer_ledger",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_ledger (mer_id, mer_name, ",
        "platform_type, platform_no, ",
        "cup_no, receiver_no, ",
        "receiver_status, split_lowest_ratio, ",
        "split_entrust_file_name, split_entrust_file_path, ",
        "`status`, reject_reason, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merId,jdbcType=BIGINT}, #{merName,jdbcType=VARCHAR}, ",
        "#{platformType,jdbcType=INTEGER}, #{platformNo,jdbcType=VARCHAR}, ",
        "#{cupNo,jdbcType=VARCHAR}, #{receiverNo,jdbcType=VARCHAR}, ",
        "#{receiverStatus,jdbcType=BIT}, #{splitLowestRatio,jdbcType=DECIMAL}, ",
        "#{splitEntrustFileName,jdbcType=VARCHAR}, #{splitEntrustFilePath,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{rejectReason,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerLedger record);

    @InsertProvider(type=BsMerLedgerSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerLedger record);

    @SelectProvider(type=BsMerLedgerSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_type", property="platformType", jdbcType=JdbcType.INTEGER),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_no", property="receiverNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_status", property="receiverStatus", jdbcType=JdbcType.BIT),
        @Result(column="split_lowest_ratio", property="splitLowestRatio", jdbcType=JdbcType.DECIMAL),
        @Result(column="split_entrust_file_name", property="splitEntrustFileName", jdbcType=JdbcType.VARCHAR),
        @Result(column="split_entrust_file_path", property="splitEntrustFilePath", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="reject_reason", property="rejectReason", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerLedger> selectByExample(BsMerLedgerExample example);

    @Select({
        "select",
        "id, mer_id, mer_name, platform_type, platform_no, cup_no, receiver_no, receiver_status, ",
        "split_lowest_ratio, split_entrust_file_name, split_entrust_file_path, `status`, ",
        "reject_reason, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_mer_ledger",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_type", property="platformType", jdbcType=JdbcType.INTEGER),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_no", property="receiverNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_status", property="receiverStatus", jdbcType=JdbcType.BIT),
        @Result(column="split_lowest_ratio", property="splitLowestRatio", jdbcType=JdbcType.DECIMAL),
        @Result(column="split_entrust_file_name", property="splitEntrustFileName", jdbcType=JdbcType.VARCHAR),
        @Result(column="split_entrust_file_path", property="splitEntrustFilePath", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="reject_reason", property="rejectReason", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerLedger selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerLedgerSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerLedger record, @Param("example") BsMerLedgerExample example);

    @UpdateProvider(type=BsMerLedgerSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerLedger record, @Param("example") BsMerLedgerExample example);

    @UpdateProvider(type=BsMerLedgerSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerLedger record);

    @Update({
        "update bs_mer_ledger",
        "set mer_id = #{merId,jdbcType=BIGINT},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "platform_type = #{platformType,jdbcType=INTEGER},",
          "platform_no = #{platformNo,jdbcType=VARCHAR},",
          "cup_no = #{cupNo,jdbcType=VARCHAR},",
          "receiver_no = #{receiverNo,jdbcType=VARCHAR},",
          "receiver_status = #{receiverStatus,jdbcType=BIT},",
          "split_lowest_ratio = #{splitLowestRatio,jdbcType=DECIMAL},",
          "split_entrust_file_name = #{splitEntrustFileName,jdbcType=VARCHAR},",
          "split_entrust_file_path = #{splitEntrustFilePath,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "reject_reason = #{rejectReason,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerLedger record);
}