package com.hfkj.dao;

import com.hfkj.entity.BsMerLedgerReceiver;
import com.hfkj.entity.BsMerLedgerReceiverExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerLedgerReceiverMapper extends BsMerLedgerReceiverMapperExt {
    @SelectProvider(type=BsMerLedgerReceiverSqlProvider.class, method="countByExample")
    long countByExample(BsMerLedgerReceiverExample example);

    @DeleteProvider(type=BsMerLedgerReceiverSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerLedgerReceiverExample example);

    @Delete({
        "delete from bs_mer_ledger_receiver",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_ledger_receiver (mer_id, mer_ledger_id, ",
        "platform_type, platform_no, ",
        "cup_no, receiver_no, ",
        "receiver_name, entrust_file_name, ",
        "entrust_file_path, relieve_entrust_file_name, ",
        "relieve_entrust_file_path, `status`, ",
        "audit_status, reject_reason, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merId,jdbcType=BIGINT}, #{merLedgerId,jdbcType=BIGINT}, ",
        "#{platformType,jdbcType=INTEGER}, #{platformNo,jdbcType=VARCHAR}, ",
        "#{cupNo,jdbcType=VARCHAR}, #{receiverNo,jdbcType=VARCHAR}, ",
        "#{receiverName,jdbcType=VARCHAR}, #{entrustFileName,jdbcType=VARCHAR}, ",
        "#{entrustFilePath,jdbcType=VARCHAR}, #{relieveEntrustFileName,jdbcType=VARCHAR}, ",
        "#{relieveEntrustFilePath,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{auditStatus,jdbcType=INTEGER}, #{rejectReason,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerLedgerReceiver record);

    @InsertProvider(type=BsMerLedgerReceiverSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerLedgerReceiver record);

    @SelectProvider(type=BsMerLedgerReceiverSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_ledger_id", property="merLedgerId", jdbcType=JdbcType.BIGINT),
        @Result(column="platform_type", property="platformType", jdbcType=JdbcType.INTEGER),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_no", property="receiverNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_name", property="receiverName", jdbcType=JdbcType.VARCHAR),
        @Result(column="entrust_file_name", property="entrustFileName", jdbcType=JdbcType.VARCHAR),
        @Result(column="entrust_file_path", property="entrustFilePath", jdbcType=JdbcType.VARCHAR),
        @Result(column="relieve_entrust_file_name", property="relieveEntrustFileName", jdbcType=JdbcType.VARCHAR),
        @Result(column="relieve_entrust_file_path", property="relieveEntrustFilePath", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="audit_status", property="auditStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="reject_reason", property="rejectReason", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerLedgerReceiver> selectByExample(BsMerLedgerReceiverExample example);

    @Select({
        "select",
        "id, mer_id, mer_ledger_id, platform_type, platform_no, cup_no, receiver_no, ",
        "receiver_name, entrust_file_name, entrust_file_path, relieve_entrust_file_name, ",
        "relieve_entrust_file_path, `status`, audit_status, reject_reason, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_mer_ledger_receiver",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_ledger_id", property="merLedgerId", jdbcType=JdbcType.BIGINT),
        @Result(column="platform_type", property="platformType", jdbcType=JdbcType.INTEGER),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_no", property="receiverNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="receiver_name", property="receiverName", jdbcType=JdbcType.VARCHAR),
        @Result(column="entrust_file_name", property="entrustFileName", jdbcType=JdbcType.VARCHAR),
        @Result(column="entrust_file_path", property="entrustFilePath", jdbcType=JdbcType.VARCHAR),
        @Result(column="relieve_entrust_file_name", property="relieveEntrustFileName", jdbcType=JdbcType.VARCHAR),
        @Result(column="relieve_entrust_file_path", property="relieveEntrustFilePath", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="audit_status", property="auditStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="reject_reason", property="rejectReason", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerLedgerReceiver selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerLedgerReceiverSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerLedgerReceiver record, @Param("example") BsMerLedgerReceiverExample example);

    @UpdateProvider(type=BsMerLedgerReceiverSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerLedgerReceiver record, @Param("example") BsMerLedgerReceiverExample example);

    @UpdateProvider(type=BsMerLedgerReceiverSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerLedgerReceiver record);

    @Update({
        "update bs_mer_ledger_receiver",
        "set mer_id = #{merId,jdbcType=BIGINT},",
          "mer_ledger_id = #{merLedgerId,jdbcType=BIGINT},",
          "platform_type = #{platformType,jdbcType=INTEGER},",
          "platform_no = #{platformNo,jdbcType=VARCHAR},",
          "cup_no = #{cupNo,jdbcType=VARCHAR},",
          "receiver_no = #{receiverNo,jdbcType=VARCHAR},",
          "receiver_name = #{receiverName,jdbcType=VARCHAR},",
          "entrust_file_name = #{entrustFileName,jdbcType=VARCHAR},",
          "entrust_file_path = #{entrustFilePath,jdbcType=VARCHAR},",
          "relieve_entrust_file_name = #{relieveEntrustFileName,jdbcType=VARCHAR},",
          "relieve_entrust_file_path = #{relieveEntrustFilePath,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "audit_status = #{auditStatus,jdbcType=INTEGER},",
          "reject_reason = #{rejectReason,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerLedgerReceiver record);
}