package com.hfkj.dao;

import com.hfkj.entity.BsMerLedgerReceiver;
import com.hfkj.entity.BsMerLedgerReceiverExample.Criteria;
import com.hfkj.entity.BsMerLedgerReceiverExample.Criterion;
import com.hfkj.entity.BsMerLedgerReceiverExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsMerLedgerReceiverSqlProvider {

    public String countByExample(BsMerLedgerReceiverExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_mer_ledger_receiver");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsMerLedgerReceiverExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_mer_ledger_receiver");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsMerLedgerReceiver record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_mer_ledger_receiver");
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerLedgerId() != null) {
            sql.VALUES("mer_ledger_id", "#{merLedgerId,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformType() != null) {
            sql.VALUES("platform_type", "#{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.VALUES("platform_no", "#{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.VALUES("cup_no", "#{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverNo() != null) {
            sql.VALUES("receiver_no", "#{receiverNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverName() != null) {
            sql.VALUES("receiver_name", "#{receiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getEntrustFileName() != null) {
            sql.VALUES("entrust_file_name", "#{entrustFileName,jdbcType=VARCHAR}");
        }
        
        if (record.getEntrustFilePath() != null) {
            sql.VALUES("entrust_file_path", "#{entrustFilePath,jdbcType=VARCHAR}");
        }
        
        if (record.getRelieveEntrustFileName() != null) {
            sql.VALUES("relieve_entrust_file_name", "#{relieveEntrustFileName,jdbcType=VARCHAR}");
        }
        
        if (record.getRelieveEntrustFilePath() != null) {
            sql.VALUES("relieve_entrust_file_path", "#{relieveEntrustFilePath,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getAuditStatus() != null) {
            sql.VALUES("audit_status", "#{auditStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRejectReason() != null) {
            sql.VALUES("reject_reason", "#{rejectReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsMerLedgerReceiverExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_id");
        sql.SELECT("mer_ledger_id");
        sql.SELECT("platform_type");
        sql.SELECT("platform_no");
        sql.SELECT("cup_no");
        sql.SELECT("receiver_no");
        sql.SELECT("receiver_name");
        sql.SELECT("entrust_file_name");
        sql.SELECT("entrust_file_path");
        sql.SELECT("relieve_entrust_file_name");
        sql.SELECT("relieve_entrust_file_path");
        sql.SELECT("`status`");
        sql.SELECT("audit_status");
        sql.SELECT("reject_reason");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_mer_ledger_receiver");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsMerLedgerReceiver record = (BsMerLedgerReceiver) parameter.get("record");
        BsMerLedgerReceiverExample example = (BsMerLedgerReceiverExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_ledger_receiver");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerLedgerId() != null) {
            sql.SET("mer_ledger_id = #{record.merLedgerId,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverNo() != null) {
            sql.SET("receiver_no = #{record.receiverNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverName() != null) {
            sql.SET("receiver_name = #{record.receiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getEntrustFileName() != null) {
            sql.SET("entrust_file_name = #{record.entrustFileName,jdbcType=VARCHAR}");
        }
        
        if (record.getEntrustFilePath() != null) {
            sql.SET("entrust_file_path = #{record.entrustFilePath,jdbcType=VARCHAR}");
        }
        
        if (record.getRelieveEntrustFileName() != null) {
            sql.SET("relieve_entrust_file_name = #{record.relieveEntrustFileName,jdbcType=VARCHAR}");
        }
        
        if (record.getRelieveEntrustFilePath() != null) {
            sql.SET("relieve_entrust_file_path = #{record.relieveEntrustFilePath,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getAuditStatus() != null) {
            sql.SET("audit_status = #{record.auditStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRejectReason() != null) {
            sql.SET("reject_reason = #{record.rejectReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_ledger_receiver");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_ledger_id = #{record.merLedgerId,jdbcType=BIGINT}");
        sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        sql.SET("platform_no = #{record.platformNo,jdbcType=VARCHAR}");
        sql.SET("cup_no = #{record.cupNo,jdbcType=VARCHAR}");
        sql.SET("receiver_no = #{record.receiverNo,jdbcType=VARCHAR}");
        sql.SET("receiver_name = #{record.receiverName,jdbcType=VARCHAR}");
        sql.SET("entrust_file_name = #{record.entrustFileName,jdbcType=VARCHAR}");
        sql.SET("entrust_file_path = #{record.entrustFilePath,jdbcType=VARCHAR}");
        sql.SET("relieve_entrust_file_name = #{record.relieveEntrustFileName,jdbcType=VARCHAR}");
        sql.SET("relieve_entrust_file_path = #{record.relieveEntrustFilePath,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("audit_status = #{record.auditStatus,jdbcType=INTEGER}");
        sql.SET("reject_reason = #{record.rejectReason,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsMerLedgerReceiverExample example = (BsMerLedgerReceiverExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsMerLedgerReceiver record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_mer_ledger_receiver");
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerLedgerId() != null) {
            sql.SET("mer_ledger_id = #{merLedgerId,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformNo() != null) {
            sql.SET("platform_no = #{platformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCupNo() != null) {
            sql.SET("cup_no = #{cupNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverNo() != null) {
            sql.SET("receiver_no = #{receiverNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverName() != null) {
            sql.SET("receiver_name = #{receiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getEntrustFileName() != null) {
            sql.SET("entrust_file_name = #{entrustFileName,jdbcType=VARCHAR}");
        }
        
        if (record.getEntrustFilePath() != null) {
            sql.SET("entrust_file_path = #{entrustFilePath,jdbcType=VARCHAR}");
        }
        
        if (record.getRelieveEntrustFileName() != null) {
            sql.SET("relieve_entrust_file_name = #{relieveEntrustFileName,jdbcType=VARCHAR}");
        }
        
        if (record.getRelieveEntrustFilePath() != null) {
            sql.SET("relieve_entrust_file_path = #{relieveEntrustFilePath,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getAuditStatus() != null) {
            sql.SET("audit_status = #{auditStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRejectReason() != null) {
            sql.SET("reject_reason = #{rejectReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsMerLedgerReceiverExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}