package com.hfkj.dao;

import com.hfkj.entity.BsMerPlatformNo;
import com.hfkj.entity.BsMerPlatformNoExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerPlatformNoMapper extends BsMerPlatformNoMapperExt {
    @SelectProvider(type=BsMerPlatformNoSqlProvider.class, method="countByExample")
    long countByExample(BsMerPlatformNoExample example);

    @DeleteProvider(type=BsMerPlatformNoSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerPlatformNoExample example);

    @Delete({
        "delete from bs_mer_platform_no",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_platform_no (company_id, agent_id, ",
        "mer_id, mer_no, platform_type, ",
        "platform_no, cup_no, ",
        "pos_id, branch_id, ",
        "mer_public_key, platform_operator_id, ",
        "platform_operator_pwd, refund_cert_url, ",
        "refund_cert_pwd, `status`, ",
        "suggestion_reject, current_platform, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{companyId,jdbcType=BIGINT}, #{agentId,jdbcType=BIGINT}, ",
        "#{merId,jdbcType=BIGINT}, #{merNo,jdbcType=VARCHAR}, #{platformType,jdbcType=INTEGER}, ",
        "#{platformNo,jdbcType=VARCHAR}, #{cupNo,jdbcType=VARCHAR}, ",
        "#{posId,jdbcType=VARCHAR}, #{branchId,jdbcType=VARCHAR}, ",
        "#{merPublicKey,jdbcType=VARCHAR}, #{platformOperatorId,jdbcType=VARCHAR}, ",
        "#{platformOperatorPwd,jdbcType=VARCHAR}, #{refundCertUrl,jdbcType=VARCHAR}, ",
        "#{refundCertPwd,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{suggestionReject,jdbcType=VARCHAR}, #{currentPlatform,jdbcType=BIT}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerPlatformNo record);

    @InsertProvider(type=BsMerPlatformNoSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerPlatformNo record);

    @SelectProvider(type=BsMerPlatformNoSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_type", property="platformType", jdbcType=JdbcType.INTEGER),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pos_id", property="posId", jdbcType=JdbcType.VARCHAR),
        @Result(column="branch_id", property="branchId", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_public_key", property="merPublicKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_operator_id", property="platformOperatorId", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_operator_pwd", property="platformOperatorPwd", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_cert_url", property="refundCertUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_cert_pwd", property="refundCertPwd", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="suggestion_reject", property="suggestionReject", jdbcType=JdbcType.VARCHAR),
        @Result(column="current_platform", property="currentPlatform", jdbcType=JdbcType.BIT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerPlatformNo> selectByExample(BsMerPlatformNoExample example);

    @Select({
        "select",
        "id, company_id, agent_id, mer_id, mer_no, platform_type, platform_no, cup_no, ",
        "pos_id, branch_id, mer_public_key, platform_operator_id, platform_operator_pwd, ",
        "refund_cert_url, refund_cert_pwd, `status`, suggestion_reject, current_platform, ",
        "create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_mer_platform_no",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_type", property="platformType", jdbcType=JdbcType.INTEGER),
        @Result(column="platform_no", property="platformNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cup_no", property="cupNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pos_id", property="posId", jdbcType=JdbcType.VARCHAR),
        @Result(column="branch_id", property="branchId", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_public_key", property="merPublicKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_operator_id", property="platformOperatorId", jdbcType=JdbcType.VARCHAR),
        @Result(column="platform_operator_pwd", property="platformOperatorPwd", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_cert_url", property="refundCertUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_cert_pwd", property="refundCertPwd", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="suggestion_reject", property="suggestionReject", jdbcType=JdbcType.VARCHAR),
        @Result(column="current_platform", property="currentPlatform", jdbcType=JdbcType.BIT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerPlatformNo selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerPlatformNoSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerPlatformNo record, @Param("example") BsMerPlatformNoExample example);

    @UpdateProvider(type=BsMerPlatformNoSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerPlatformNo record, @Param("example") BsMerPlatformNoExample example);

    @UpdateProvider(type=BsMerPlatformNoSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerPlatformNo record);

    @Update({
        "update bs_mer_platform_no",
        "set company_id = #{companyId,jdbcType=BIGINT},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "platform_type = #{platformType,jdbcType=INTEGER},",
          "platform_no = #{platformNo,jdbcType=VARCHAR},",
          "cup_no = #{cupNo,jdbcType=VARCHAR},",
          "pos_id = #{posId,jdbcType=VARCHAR},",
          "branch_id = #{branchId,jdbcType=VARCHAR},",
          "mer_public_key = #{merPublicKey,jdbcType=VARCHAR},",
          "platform_operator_id = #{platformOperatorId,jdbcType=VARCHAR},",
          "platform_operator_pwd = #{platformOperatorPwd,jdbcType=VARCHAR},",
          "refund_cert_url = #{refundCertUrl,jdbcType=VARCHAR},",
          "refund_cert_pwd = #{refundCertPwd,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "suggestion_reject = #{suggestionReject,jdbcType=VARCHAR},",
          "current_platform = #{currentPlatform,jdbcType=BIT},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerPlatformNo record);
}