package com.hfkj.dao;

import com.hfkj.entity.BsMerPlatformTerm;
import com.hfkj.entity.BsMerPlatformTermExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerPlatformTermMapper extends BsMerPlatformTermMapperExt {
    @SelectProvider(type=BsMerPlatformTermSqlProvider.class, method="countByExample")
    long countByExample(BsMerPlatformTermExample example);

    @DeleteProvider(type=BsMerPlatformTermSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerPlatformTermExample example);

    @Delete({
        "delete from bs_mer_platform_term",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_platform_term (mer_platform_no_id, mer_id, ",
        "active_no, busi_type_code, ",
        "busi_type_name, product_code, ",
        "product_name, shop_id, ",
        "term_id, term_no, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{merPlatformNoId,jdbcType=BIGINT}, #{merId,jdbcType=BIGINT}, ",
        "#{activeNo,jdbcType=VARCHAR}, #{busiTypeCode,jdbcType=VARCHAR}, ",
        "#{busiTypeName,jdbcType=VARCHAR}, #{productCode,jdbcType=VARCHAR}, ",
        "#{productName,jdbcType=VARCHAR}, #{shopId,jdbcType=VARCHAR}, ",
        "#{termId,jdbcType=VARCHAR}, #{termNo,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerPlatformTerm record);

    @InsertProvider(type=BsMerPlatformTermSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerPlatformTerm record);

    @SelectProvider(type=BsMerPlatformTermSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_platform_no_id", property="merPlatformNoId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="active_no", property="activeNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="busi_type_code", property="busiTypeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="busi_type_name", property="busiTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_code", property="productCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="shop_id", property="shopId", jdbcType=JdbcType.VARCHAR),
        @Result(column="term_id", property="termId", jdbcType=JdbcType.VARCHAR),
        @Result(column="term_no", property="termNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerPlatformTerm> selectByExample(BsMerPlatformTermExample example);

    @Select({
        "select",
        "id, mer_platform_no_id, mer_id, active_no, busi_type_code, busi_type_name, product_code, ",
        "product_name, shop_id, term_id, term_no, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_mer_platform_term",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_platform_no_id", property="merPlatformNoId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="active_no", property="activeNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="busi_type_code", property="busiTypeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="busi_type_name", property="busiTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_code", property="productCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="shop_id", property="shopId", jdbcType=JdbcType.VARCHAR),
        @Result(column="term_id", property="termId", jdbcType=JdbcType.VARCHAR),
        @Result(column="term_no", property="termNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerPlatformTerm selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerPlatformTermSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerPlatformTerm record, @Param("example") BsMerPlatformTermExample example);

    @UpdateProvider(type=BsMerPlatformTermSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerPlatformTerm record, @Param("example") BsMerPlatformTermExample example);

    @UpdateProvider(type=BsMerPlatformTermSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerPlatformTerm record);

    @Update({
        "update bs_mer_platform_term",
        "set mer_platform_no_id = #{merPlatformNoId,jdbcType=BIGINT},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "active_no = #{activeNo,jdbcType=VARCHAR},",
          "busi_type_code = #{busiTypeCode,jdbcType=VARCHAR},",
          "busi_type_name = #{busiTypeName,jdbcType=VARCHAR},",
          "product_code = #{productCode,jdbcType=VARCHAR},",
          "product_name = #{productName,jdbcType=VARCHAR},",
          "shop_id = #{shopId,jdbcType=VARCHAR},",
          "term_id = #{termId,jdbcType=VARCHAR},",
          "term_no = #{termNo,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerPlatformTerm record);
}