package com.hfkj.dao;

import com.hfkj.entity.BsMerRateApplyDetail;
import com.hfkj.entity.BsMerRateApplyDetailExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerRateApplyDetailMapper extends BsMerRateApplyDetailMapperExt {
    @SelectProvider(type=BsMerRateApplyDetailSqlProvider.class, method="countByExample")
    long countByExample(BsMerRateApplyDetailExample example);

    @DeleteProvider(type=BsMerRateApplyDetailSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerRateApplyDetailExample example);

    @Delete({
        "delete from bs_mer_rate_apply_detail",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer_rate_apply_detail (mer_rate_apply_id, rate_type_code, ",
        "rate_saas_type_code, rate_type_name, ",
        "rate_pct, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merRateApplyId,jdbcType=BIGINT}, #{rateTypeCode,jdbcType=INTEGER}, ",
        "#{rateSaasTypeCode,jdbcType=VARCHAR}, #{rateTypeName,jdbcType=VARCHAR}, ",
        "#{ratePct,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMerRateApplyDetail record);

    @InsertProvider(type=BsMerRateApplyDetailSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMerRateApplyDetail record);

    @SelectProvider(type=BsMerRateApplyDetailSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_rate_apply_id", property="merRateApplyId", jdbcType=JdbcType.BIGINT),
        @Result(column="rate_type_code", property="rateTypeCode", jdbcType=JdbcType.INTEGER),
        @Result(column="rate_saas_type_code", property="rateSaasTypeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="rate_type_name", property="rateTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="rate_pct", property="ratePct", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMerRateApplyDetail> selectByExample(BsMerRateApplyDetailExample example);

    @Select({
        "select",
        "id, mer_rate_apply_id, rate_type_code, rate_saas_type_code, rate_type_name, ",
        "rate_pct, `status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_mer_rate_apply_detail",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_rate_apply_id", property="merRateApplyId", jdbcType=JdbcType.BIGINT),
        @Result(column="rate_type_code", property="rateTypeCode", jdbcType=JdbcType.INTEGER),
        @Result(column="rate_saas_type_code", property="rateSaasTypeCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="rate_type_name", property="rateTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="rate_pct", property="ratePct", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMerRateApplyDetail selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerRateApplyDetailSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMerRateApplyDetail record, @Param("example") BsMerRateApplyDetailExample example);

    @UpdateProvider(type=BsMerRateApplyDetailSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMerRateApplyDetail record, @Param("example") BsMerRateApplyDetailExample example);

    @UpdateProvider(type=BsMerRateApplyDetailSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMerRateApplyDetail record);

    @Update({
        "update bs_mer_rate_apply_detail",
        "set mer_rate_apply_id = #{merRateApplyId,jdbcType=BIGINT},",
          "rate_type_code = #{rateTypeCode,jdbcType=INTEGER},",
          "rate_saas_type_code = #{rateSaasTypeCode,jdbcType=VARCHAR},",
          "rate_type_name = #{rateTypeName,jdbcType=VARCHAR},",
          "rate_pct = #{ratePct,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMerRateApplyDetail record);
}