package com.hfkj.dao;

import com.hfkj.entity.BsRebateActivityAccount;
import com.hfkj.entity.BsRebateActivityAccountExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsRebateActivityAccountMapper extends BsRebateActivityAccountMapperExt {
    @SelectProvider(type=BsRebateActivityAccountSqlProvider.class, method="countByExample")
    long countByExample(BsRebateActivityAccountExample example);

    @DeleteProvider(type=BsRebateActivityAccountSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsRebateActivityAccountExample example);

    @Delete({
        "delete from bs_rebate_activity_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_rebate_activity_account (activity_id, activity_no, ",
        "amount, create_time, ",
        "update_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{activityId,jdbcType=BIGINT}, #{activityNo,jdbcType=VARCHAR}, ",
        "#{amount,jdbcType=DECIMAL}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsRebateActivityAccount record);

    @InsertProvider(type=BsRebateActivityAccountSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsRebateActivityAccount record);

    @SelectProvider(type=BsRebateActivityAccountSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_id", property="activityId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_no", property="activityNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsRebateActivityAccount> selectByExample(BsRebateActivityAccountExample example);

    @Select({
        "select",
        "id, activity_id, activity_no, amount, create_time, update_time, `status`, ext_1, ",
        "ext_2, ext_3",
        "from bs_rebate_activity_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_id", property="activityId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_no", property="activityNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsRebateActivityAccount selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsRebateActivityAccountSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsRebateActivityAccount record, @Param("example") BsRebateActivityAccountExample example);

    @UpdateProvider(type=BsRebateActivityAccountSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsRebateActivityAccount record, @Param("example") BsRebateActivityAccountExample example);

    @UpdateProvider(type=BsRebateActivityAccountSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsRebateActivityAccount record);

    @Update({
        "update bs_rebate_activity_account",
        "set activity_id = #{activityId,jdbcType=BIGINT},",
          "activity_no = #{activityNo,jdbcType=VARCHAR},",
          "amount = #{amount,jdbcType=DECIMAL},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsRebateActivityAccount record);
}