package com.hfkj.dao;

import com.hfkj.entity.BsRebateActivity;
import com.hfkj.entity.BsRebateActivityExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsRebateActivityMapper extends BsRebateActivityMapperExt {
    @SelectProvider(type=BsRebateActivitySqlProvider.class, method="countByExample")
    long countByExample(BsRebateActivityExample example);

    @DeleteProvider(type=BsRebateActivitySqlProvider.class, method="deleteByExample")
    int deleteByExample(BsRebateActivityExample example);

    @Delete({
        "delete from bs_rebate_activity",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_rebate_activity (mer_id, mer_no, ",
        "mer_name, mer_abbreviate, ",
        "activity_no, activity_type, ",
        "preferential_type, `condition`, ",
        "price, restrict_partake_type, ",
        "restrict_partake_num, start_time, ",
        "end_time, reality_end_time, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{merId,jdbcType=BIGINT}, #{merNo,jdbcType=VARCHAR}, ",
        "#{merName,jdbcType=VARCHAR}, #{merAbbreviate,jdbcType=VARCHAR}, ",
        "#{activityNo,jdbcType=VARCHAR}, #{activityType,jdbcType=INTEGER}, ",
        "#{preferentialType,jdbcType=INTEGER}, #{condition,jdbcType=DECIMAL}, ",
        "#{price,jdbcType=DECIMAL}, #{restrictPartakeType,jdbcType=INTEGER}, ",
        "#{restrictPartakeNum,jdbcType=INTEGER}, #{startTime,jdbcType=TIMESTAMP}, ",
        "#{endTime,jdbcType=TIMESTAMP}, #{realityEndTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsRebateActivity record);

    @InsertProvider(type=BsRebateActivitySqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsRebateActivity record);

    @SelectProvider(type=BsRebateActivitySqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_abbreviate", property="merAbbreviate", jdbcType=JdbcType.VARCHAR),
        @Result(column="activity_no", property="activityNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="activity_type", property="activityType", jdbcType=JdbcType.INTEGER),
        @Result(column="preferential_type", property="preferentialType", jdbcType=JdbcType.INTEGER),
        @Result(column="condition", property="condition", jdbcType=JdbcType.DECIMAL),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="restrict_partake_type", property="restrictPartakeType", jdbcType=JdbcType.INTEGER),
        @Result(column="restrict_partake_num", property="restrictPartakeNum", jdbcType=JdbcType.INTEGER),
        @Result(column="start_time", property="startTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="end_time", property="endTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="reality_end_time", property="realityEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsRebateActivity> selectByExample(BsRebateActivityExample example);

    @Select({
        "select",
        "id, mer_id, mer_no, mer_name, mer_abbreviate, activity_no, activity_type, preferential_type, ",
        "`condition`, price, restrict_partake_type, restrict_partake_num, start_time, ",
        "end_time, reality_end_time, `status`, create_time, update_time, ext_1, ext_2, ",
        "ext_3",
        "from bs_rebate_activity",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_abbreviate", property="merAbbreviate", jdbcType=JdbcType.VARCHAR),
        @Result(column="activity_no", property="activityNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="activity_type", property="activityType", jdbcType=JdbcType.INTEGER),
        @Result(column="preferential_type", property="preferentialType", jdbcType=JdbcType.INTEGER),
        @Result(column="condition", property="condition", jdbcType=JdbcType.DECIMAL),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="restrict_partake_type", property="restrictPartakeType", jdbcType=JdbcType.INTEGER),
        @Result(column="restrict_partake_num", property="restrictPartakeNum", jdbcType=JdbcType.INTEGER),
        @Result(column="start_time", property="startTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="end_time", property="endTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="reality_end_time", property="realityEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsRebateActivity selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsRebateActivitySqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsRebateActivity record, @Param("example") BsRebateActivityExample example);

    @UpdateProvider(type=BsRebateActivitySqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsRebateActivity record, @Param("example") BsRebateActivityExample example);

    @UpdateProvider(type=BsRebateActivitySqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsRebateActivity record);

    @Update({
        "update bs_rebate_activity",
        "set mer_id = #{merId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "mer_abbreviate = #{merAbbreviate,jdbcType=VARCHAR},",
          "activity_no = #{activityNo,jdbcType=VARCHAR},",
          "activity_type = #{activityType,jdbcType=INTEGER},",
          "preferential_type = #{preferentialType,jdbcType=INTEGER},",
          "`condition` = #{condition,jdbcType=DECIMAL},",
          "price = #{price,jdbcType=DECIMAL},",
          "restrict_partake_type = #{restrictPartakeType,jdbcType=INTEGER},",
          "restrict_partake_num = #{restrictPartakeNum,jdbcType=INTEGER},",
          "start_time = #{startTime,jdbcType=TIMESTAMP},",
          "end_time = #{endTime,jdbcType=TIMESTAMP},",
          "reality_end_time = #{realityEndTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsRebateActivity record);
}