package com.hfkj.dao;

import com.hfkj.entity.BsRebateReward;
import com.hfkj.entity.BsRebateRewardExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsRebateRewardMapper extends BsRebateRewardMapperExt {
    @SelectProvider(type=BsRebateRewardSqlProvider.class, method="countByExample")
    long countByExample(BsRebateRewardExample example);

    @DeleteProvider(type=BsRebateRewardSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsRebateRewardExample example);

    @Delete({
        "delete from bs_rebate_reward",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_rebate_reward (batch_identifier, time_start, ",
        "time_end, amount, ",
        "part_mer_num, part_trade_amount, ",
        "ratio, `status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{batchIdentifier,jdbcType=BIGINT}, #{timeStart,jdbcType=TIMESTAMP}, ",
        "#{timeEnd,jdbcType=TIMESTAMP}, #{amount,jdbcType=DECIMAL}, ",
        "#{partMerNum,jdbcType=INTEGER}, #{partTradeAmount,jdbcType=DECIMAL}, ",
        "#{ratio,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsRebateReward record);

    @InsertProvider(type=BsRebateRewardSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsRebateReward record);

    @SelectProvider(type=BsRebateRewardSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="batch_identifier", property="batchIdentifier", jdbcType=JdbcType.BIGINT),
        @Result(column="time_start", property="timeStart", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="time_end", property="timeEnd", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="part_mer_num", property="partMerNum", jdbcType=JdbcType.INTEGER),
        @Result(column="part_trade_amount", property="partTradeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="ratio", property="ratio", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsRebateReward> selectByExample(BsRebateRewardExample example);

    @Select({
        "select",
        "id, batch_identifier, time_start, time_end, amount, part_mer_num, part_trade_amount, ",
        "ratio, `status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_rebate_reward",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="batch_identifier", property="batchIdentifier", jdbcType=JdbcType.BIGINT),
        @Result(column="time_start", property="timeStart", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="time_end", property="timeEnd", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="part_mer_num", property="partMerNum", jdbcType=JdbcType.INTEGER),
        @Result(column="part_trade_amount", property="partTradeAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="ratio", property="ratio", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsRebateReward selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsRebateRewardSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsRebateReward record, @Param("example") BsRebateRewardExample example);

    @UpdateProvider(type=BsRebateRewardSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsRebateReward record, @Param("example") BsRebateRewardExample example);

    @UpdateProvider(type=BsRebateRewardSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsRebateReward record);

    @Update({
        "update bs_rebate_reward",
        "set batch_identifier = #{batchIdentifier,jdbcType=BIGINT},",
          "time_start = #{timeStart,jdbcType=TIMESTAMP},",
          "time_end = #{timeEnd,jdbcType=TIMESTAMP},",
          "amount = #{amount,jdbcType=DECIMAL},",
          "part_mer_num = #{partMerNum,jdbcType=INTEGER},",
          "part_trade_amount = #{partTradeAmount,jdbcType=DECIMAL},",
          "ratio = #{ratio,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsRebateReward record);
}