package com.hfkj.dao;

import com.hfkj.entity.BsRebateRewardRoster;
import com.hfkj.entity.BsRebateRewardRosterExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsRebateRewardRosterMapper extends BsRebateRewardRosterMapperExt {
    @SelectProvider(type=BsRebateRewardRosterSqlProvider.class, method="countByExample")
    long countByExample(BsRebateRewardRosterExample example);

    @DeleteProvider(type=BsRebateRewardRosterSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsRebateRewardRosterExample example);

    @Delete({
        "delete from bs_rebate_reward_roster",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_rebate_reward_roster (batch_identifier, salesman_id, ",
        "salesman_name, mer_id, ",
        "mer_no, mer_name, ",
        "mer_abbreviate, mer_account_number, ",
        "reward_ratio, amount, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{batchIdentifier,jdbcType=BIGINT}, #{salesmanId,jdbcType=BIGINT}, ",
        "#{salesmanName,jdbcType=VARCHAR}, #{merId,jdbcType=BIGINT}, ",
        "#{merNo,jdbcType=VARCHAR}, #{merName,jdbcType=VARCHAR}, ",
        "#{merAbbreviate,jdbcType=VARCHAR}, #{merAccountNumber,jdbcType=BIGINT}, ",
        "#{rewardRatio,jdbcType=DECIMAL}, #{amount,jdbcType=DECIMAL}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsRebateRewardRoster record);

    @InsertProvider(type=BsRebateRewardRosterSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsRebateRewardRoster record);

    @SelectProvider(type=BsRebateRewardRosterSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="batch_identifier", property="batchIdentifier", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_id", property="salesmanId", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_name", property="salesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_abbreviate", property="merAbbreviate", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_account_number", property="merAccountNumber", jdbcType=JdbcType.BIGINT),
        @Result(column="reward_ratio", property="rewardRatio", jdbcType=JdbcType.DECIMAL),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsRebateRewardRoster> selectByExample(BsRebateRewardRosterExample example);

    @Select({
        "select",
        "id, batch_identifier, salesman_id, salesman_name, mer_id, mer_no, mer_name, ",
        "mer_abbreviate, mer_account_number, reward_ratio, amount, `status`, create_time, ",
        "update_time, ext_1, ext_2, ext_3",
        "from bs_rebate_reward_roster",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="batch_identifier", property="batchIdentifier", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_id", property="salesmanId", jdbcType=JdbcType.BIGINT),
        @Result(column="salesman_name", property="salesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_abbreviate", property="merAbbreviate", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_account_number", property="merAccountNumber", jdbcType=JdbcType.BIGINT),
        @Result(column="reward_ratio", property="rewardRatio", jdbcType=JdbcType.DECIMAL),
        @Result(column="amount", property="amount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsRebateRewardRoster selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsRebateRewardRosterSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsRebateRewardRoster record, @Param("example") BsRebateRewardRosterExample example);

    @UpdateProvider(type=BsRebateRewardRosterSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsRebateRewardRoster record, @Param("example") BsRebateRewardRosterExample example);

    @UpdateProvider(type=BsRebateRewardRosterSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsRebateRewardRoster record);

    @Update({
        "update bs_rebate_reward_roster",
        "set batch_identifier = #{batchIdentifier,jdbcType=BIGINT},",
          "salesman_id = #{salesmanId,jdbcType=BIGINT},",
          "salesman_name = #{salesmanName,jdbcType=VARCHAR},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "mer_no = #{merNo,jdbcType=VARCHAR},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "mer_abbreviate = #{merAbbreviate,jdbcType=VARCHAR},",
          "mer_account_number = #{merAccountNumber,jdbcType=BIGINT},",
          "reward_ratio = #{rewardRatio,jdbcType=DECIMAL},",
          "amount = #{amount,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsRebateRewardRoster record);
}