package com.hfkj.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentStyle;
import com.alibaba.excel.annotation.write.style.HeadFontStyle;
import lombok.Data;
import org.apache.poi.ss.usermodel.HorizontalAlignment;

import java.util.Date;

/**
 * 交易账单模型
 * @className: TradeBillsModel
 * @author: HuRui
 * @date: 2023/5/25
 **/
@Data
public class TradeSettleBillsModel {

    @ColumnWidth(15)
    @ExcelProperty("清算日期")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String settleDate;

    @ColumnWidth(25)
    @ExcelProperty("商户号")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String merchantNo;

    @ColumnWidth(30)
    @ExcelProperty("商户名称")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String merchantName;

    @ColumnWidth(15)
    @ExcelProperty("交易笔数")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private Long tradeNum;

    @ColumnWidth(15)
    @ExcelProperty("交易金额")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String tradeAmount;

    @ColumnWidth(15)
    @ExcelProperty("手续费")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String shdFeeAmt;

    @ColumnWidth(15)
    @ExcelProperty("应结算金额")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String settleAmount;

}
