package com.hfkj.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentStyle;
import com.alibaba.excel.annotation.write.style.HeadFontStyle;
import lombok.Data;
import org.apache.poi.ss.usermodel.HorizontalAlignment;

import java.util.Date;

/**
 * 交易账单模型
 * @className: TradeBillsModel
 * @author: HuRui
 * @date: 2023/5/25
 **/
@Data
public class TradeSettleDetailBillsModel {

    @ColumnWidth(10)
    @ExcelProperty("序号")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private Long serialNumber;

    @ColumnWidth(25)
    @ExcelProperty("商户号")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String merchantNo;

    @ColumnWidth(30)
    @ExcelProperty("商户名称")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String merchantName;

    @ColumnWidth(25)
    @ExcelProperty("交易日期")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private Date tradeTime;

    @ColumnWidth(15)
    @ExcelProperty("交易金额")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String tradeAmount;

    @ColumnWidth(15)
    @ExcelProperty("交易手续费")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String shdFeeAmt;

    @ColumnWidth(15)
    @ExcelProperty("结算金额")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String settleAmount;

    @ColumnWidth(15)
    @ExcelProperty("交易类型")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String tradeType;

    @ColumnWidth(15)
    @ExcelProperty("支付渠道")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String payMode;

    @ColumnWidth(35)
    @ExcelProperty("商户订单号")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String outTradeNo;

    @ColumnWidth(35)
    @ExcelProperty("渠道订单号")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String accTradeNo;

    @ColumnWidth(15)
    @ExcelProperty("清算日期")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String settleDate;

    @ColumnWidth(15)
    @ExcelProperty("手续费率")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String feeRate;

    @ColumnWidth(35)
    @ExcelProperty("原商户订单号")
    @HeadFontStyle(bold = true)
    @ContentStyle(horizontalAlignment = HorizontalAlignment.CENTER)
    private String orgOutTradeNo;


}
