package com.hfkj.openapi.v1.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 交易账单模型
 * @className: TradeBillsModel
 * @author: HuRui
 * @date: 2023/5/25
 **/
@Data
public class TradeBillsModel {
    @ColumnWidth(25)
    @ExcelProperty("交易时间")
    private Date payTime;
    @ColumnWidth(25)
    @ExcelProperty("商户号")
    private String merchantNo;
    @ColumnWidth(40)
    @ExcelProperty("平台交易单号")
    private String platformTradeNo;
    @ColumnWidth(40)
    @ExcelProperty("账户端交易单号")
    private String accTradeNo;
    @ColumnWidth(40)
    @ExcelProperty("商户交易单号")
    private String outTradeNo;
    @ColumnWidth(25)
    @ExcelProperty("用户标识")
    private String payUserId;

    @ColumnWidth(20)
    @ExcelProperty("交易类型")
    private String tradeType;

    @ColumnWidth(15)
    @ExcelProperty("交易方式")
    private String payMode;

    @ColumnWidth(15)
    @ExcelProperty("交易状态")
    private String tradeStatus;

    @ColumnWidth(15)
    @ExcelProperty("交易金额")
    private BigDecimal tradeAmount;

    @ColumnWidth(20)
    @ExcelProperty("交易实付金额")
    private BigDecimal tradeActualAmount;

    @ColumnWidth(15)
    @ExcelProperty("退款类型")
    private String refundType;

    @ColumnWidth(15)
    @ExcelProperty("退款金额")
    private BigDecimal refundPrice;

    @ColumnWidth(15)
    @ExcelProperty("交易标题")
    private String subject;

    @ColumnWidth(15)
    @ExcelProperty("创建方式")
    private String createType;

}
