package com.hfkj.openapi.v1.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 交易退款账单模型
 * @className: TradeBillsModel
 * @author: HuRui
 * @date: 2023/5/25
 **/
@Data
public class TradeRefundBillsModel {

    @ColumnWidth(25)
    @ExcelProperty("申请退款时间")
    private Date createTime;

    @ColumnWidth(35)
    @ExcelProperty("商户退款单号")
    private String refundNo;

    @ColumnWidth(25)
    @ExcelProperty("退款状态")
    private String refundStatus;

    @ColumnWidth(25)
    @ExcelProperty("退款成功时间")
    private Date refundTime;

    @ColumnWidth(25)
    @ExcelProperty("退款金额")
    private BigDecimal refundAmount;

    @ColumnWidth(35)
    @ExcelProperty("商户交易单号")
    private String outTradeNo;

    @ColumnWidth(35)
    @ExcelProperty("账户端交易单号")
    private String accTradeNo;

    @ColumnWidth(30)
    @ExcelProperty("商户号")
    private String merNo;

    @ColumnWidth(25)
    @ExcelProperty("交易金额")
    private BigDecimal accSettleAmount;

    @ColumnWidth(30)
    @ExcelProperty("退款原因")
    private String refundReason;

    @ColumnWidth(25)
    @ExcelProperty("操作人")
    private String operatorName;

}
