package com.hfkj.openapi.v1.model.request;

import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;

/**
 * 请求查询交易模型
 * @className: TradePreorderModel
 * @author: HuRui
 * @date: 2023/5/23
 **/
@Data
public class RequestQueryRefundModel {

    /**
     * 商户号
     */
    @NotBlank(message = "商户号必填项")
    private String merchantNo;

    /**
     * 退款单号
     */
    @Length(min = 6, max = 50, message = "退款单号长度限制6至50位字符串长度")
    @NotBlank(message = "退款单号必填项")
    private String refundTradeNo;

    /**
     * 签名参数
     */
    @NotBlank(message = "签名必填项")
    private String sign;

}
