package com.hfkj.openapi.v1.model.request;

import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.Valid;
import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 请求分账
 * @className: RequestSeparateModel
 * @author: HuRui
 * @date: 2023/5/26
 **/
@Data
public class RequestSeparateQueryModel {

    /**
     * 商户号
     */
    @NotBlank(message = "商户号必填项")
    private String merchantNo;

    /**
     * 分账流水号
     */
    @NotBlank(message = "分账流水号必填项")
    @Length(min = 6, max = 50, message = "分账流水号限制6至50位字符串长度")
    private String outSeparateNo;

    /**
     * 签名参数
     */
    @NotBlank(message = "签名必填项")
    private String sign;

}
