package com.hfkj.openapi.v1.model.request;

import lombok.Data;

import javax.validation.constraints.NotBlank;

/**
 * 请求账单下载模型
 * @className: TradePreorderModel
 * @author: HuRui
 * @date: 2023/5/23
 **/
@Data
public class RequestTradeRefundBillsModel {

    /**
     * 商户号
     */
    @NotBlank(message = "商户号必填项")
    private String merchantNo;

    /**
     * 报表开始时间
     */
    @NotBlank(message = "开始时间必填项")
    private Long billDateS;

    /**
     * 报表结束时间
     */
    @NotBlank(message = "结束时间必填项")
    private Long billDateE;

    /**
     * 签名参数
     */
    @NotBlank(message = "签名必填项")
    private String sign;

}
