package com.hfkj.openapi.v1.model.response;

import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 响应查询交易模型
 * @className: TradePreorderModel
 * @author: HuRui
 * @date: 2023/5/23
 **/
@Data
public class ResponseQueryTradeModel {

    /**
     * 商户号
     */
    private String merchantNo;

    /**
     * 商户交易单号
     */
    private String outTradeNo;

    /**
     * 账户端交易单号
     */
    private String accTradeNo;

    /**
     * 用户标识
     */
    private String userId;

    /**
     * 支付方式
     */
    private String payMode;

    /**
     * 交易金额
     */
    private BigDecimal tradeAmount;

    /**
     * 交易实付金额
     */
    private BigDecimal tradeActualAmount;

    /**
     * 交易状态
     */
    private Integer status;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 支付时间
     */
    private Date payTime;

    /**
     * 附加参数
     */
    private String attach;

    /**
     * 签名参数
     */
    private String sign;

}
