package com.hfkj.openapi.v1.service;

import com.hfkj.openapi.v1.model.request.RequestSeparateCancelModel;
import com.hfkj.openapi.v1.model.request.RequestSeparateModel;
import com.hfkj.openapi.v1.model.request.RequestSeparateQueryAmtModel;
import com.hfkj.openapi.v1.model.request.RequestSeparateQueryModel;
import com.hfkj.openapi.v1.model.response.ResponseSeparateCancelModel;
import com.hfkj.openapi.v1.model.response.ResponseSeparateModel;
import com.hfkj.openapi.v1.model.response.ResponseSeparateQueryAmtModel;
import com.hfkj.openapi.v1.model.response.ResponseSeparateQueryModel;

import java.util.Map;

/**
 * 开放api 交易利润分享
 * @className: OpenApiTradeOrderProfitSharingService
 * @author: HuRui
 * @date: 2023/5/23
 **/
public interface OpenApiTradeOrderProfitSharingService {

    /**
     * 分账
     * @param separateModel
     */
    ResponseSeparateModel separate(RequestSeparateModel separateModel) throws Exception;

    /**
     * 撤销
     * @param separateCancelModel
     * @return
     */
    ResponseSeparateCancelModel cancel(RequestSeparateCancelModel separateCancelModel) throws Exception;
    /**
     * 分账查询
     * @param separateQueryModel
     * @return
     */
    ResponseSeparateQueryModel query(RequestSeparateQueryModel separateQueryModel) throws Exception;

    /**
     * 可分账金额查询
     * @param separateQueryAmtModel
     * @return
     * @throws Exception
     */
    ResponseSeparateQueryAmtModel queryAmt(RequestSeparateQueryAmtModel separateQueryAmtModel) throws Exception;
}
