package com.hfkj.service;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: CmsCategoryRoleService
 * @Description: 分类角色关联
 * @author: gongjia
 * @date: 2019/10/28 11:12
 * @Copyright: 2019 www.shinwoten.com Inc. All rights reserved.
 */
public interface CmsCategoryRoleService {

    /**
     *
     * @Title: addCategoryRoles
     * @Description: 增加 分类角色关联
     * @author: gongjia
     * @param: [categoryId, roleList]
     * @return: int
     * @throws
     */
    int addCategoryRoles(Long categoryId, List<Integer> roleList) throws Exception;

    /**
     *
     * @Title: delCategoryRoles
     * @Description: 删除 分类角色关联
     * @author: gongjia
     * @param: [paramsMap]
     * @return: int
     * @throws
     */
    int delCategoryRoles(Map<String, String> paramsMap) throws Exception;

    /**
     *
     * @Title: delSurplusRolesOfCategories
     * @Description: 删除 给定分类中(categoryIds)不在指定权限列表(roleList) 的分类角色关联
     * @author: gongjia
     * @param: [categoryIds, roleList]
     * @return: int
     * @throws
     */
    int delSurplusRolesOfCategories(List<Long> categoryIds, List<Integer> roleList) throws Exception;

}
